;; Convert a Java object, esp. one returned by JDBC, to
;; the appropriate Kawa object.

(define (kawa-convert java-object)
  (cond
   ((or (instance? java-object <java.lang.String>)
	(instance? java-object <java.lang.StringBuffer>))
    (as <string> java-object))
   ((instance? java-object <java.util.Date>)
    (let ((cal ((primitive-constructor <java.util.GregorianCalendar> ()))))
      ((primitive-virtual-method
	<java.util.Calendar> "setTime" <void> (<java.util.Date>))
       cal java-object)
      cal))
   ((instance? java-object <java.lang.Integer>)
    ((primitive-constructor <integer> (<int>))
     (as <int> java-object)))
   (else java-object)))

; FIXME: other date-related functions would be useful.
