package gnu.kawa.brl;

/*
 * BRL Servlet
 */

import java.io.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

import kawa.lang.*;
import kawa.standard.*;
import gnu.mapping.*;
import gnu.expr.*;

public class svlet extends HttpServlet
{
    Scheme interp = null;
    final String initfname = "/home/blewis/src/kawa/gnu/kawa/brl/nal.scm";
    long initfile_modified=0;

    void reloadInit()
    {
	File initfile;
	long new_modified;

	if (interp == null) interp = new Scheme();
	initfile = new File(initfname);
	new_modified = initfile.lastModified();
	if (new_modified != initfile_modified)
	    {
		interp.eval("(load \"" + initfname + "\")");
		initfile_modified = new_modified;
	    }
    }

    public void doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
    {
	PrintWriter	toclient;
	StringBuffer s_expr = new StringBuffer("(brl-handle-request \"");
	Object schemeobj;
	boolean response_started=false;
	Enumeration e;

	// Reload init file if necessary
	this.reloadInit();

	// Create s-expr to handle request
	s_expr.append(req.getPathTranslated());
	s_expr.append("\" '(");
	e = req.getParameterNames();
	while (e.hasMoreElements())
	    {
		String name = (String)e.nextElement();
		s_expr.append("(");
		s_expr.append(name);
		String vals[] = (String [])req.getParameterValues(name);
		if (vals != null && vals.length > 0)
		    {
			s_expr.append(" .");
			if (vals.length == 1)
			    {
				s_expr.append(" \"");
				s_expr.append(vals[0]);
				s_expr.append("\"");
			    }
			else
			    {
				s_expr.append("(");
				for (int i = 1; i < vals.length; i++)
				    {
					s_expr.append(" \"");
					s_expr.append(vals[i]);
					s_expr.append("\"");
				    }
				s_expr.append(")");
			    }
		    }
		s_expr.append(")");
	    }
	s_expr.append("))");

	// Send output
	try
	    {
		schemeobj=interp.eval(s_expr.toString());
		response_started=true;
		res.setContentType("text/html");
		toclient = res.getWriter();
		toclient.print(schemeobj.toString());
	    }
	catch (Throwable ex)
	    {
		if (!response_started)
		    {
			res.setContentType("text/plain");
			toclient = res.getWriter();
			ex.printStackTrace(toclient);
		    }
	    }
    }

    public String getServletInfo()
    {
	return "BRL servlet";
    }
}
